diff --git a/gnu/packages/node-xyz.scm b/gnu/packages/node-xyz.scm
index 180e4e9f69..4f61ac95b2 100644
--- a/gnu/packages/node-xyz.scm
+++ b/gnu/packages/node-xyz.scm
@@ -581,6 +581,55 @@ (define-public node-protocol-buffers-schema
 written in Javascript.")
     (license license:expat)))
 
+(define-public node-readable-stream
+  (package
+    (name "node-readable-stream")
+    (version "3.6.0")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/nodejs/readable-stream")
+             (commit (string-append "v" version))))
+       (file-name (git-file-name name version))
+       (sha256
+        (base32
+         "0ybl4cdgsm9c5jq3xq8s01201jk8w0yakh63hlclsfbcdfqhd9ri"))))
+    (build-system node-build-system)
+    (arguments
+     `(#:phases
+       (modify-phases %standard-phases
+         (add-after 'patch-dependencies 'delete-dependencies
+           (lambda args
+             (delete-dependencies `("@babel/cli"
+                                    "@babel/core"
+                                    "@babel/polyfill"
+                                    "@babel/preset-env"
+                                    "airtap"
+                                    "assert"
+                                    "bl"
+                                    "deep-strict-equal"
+                                    "events.once"
+                                    "glob"
+                                    "gunzip-maybe"
+                                    "hyperquest"
+                                    "lolex"
+                                    "nyc"
+                                    "pump"
+                                    "rimraf"
+                                    "tap"
+                                    "tape"
+                                    "tar-fs"
+                                    "util-promisify")))))
+       #:tests? #f))
+    (inputs (list node-util-deprecate node-string-decoder node-inherits))
+    (home-page "https://github.com/nodejs/readable-stream")
+    (synopsis "Node.js core streams for userland")
+    (description
+     "@code{readable-stream} provides an implementation of Node.js core streams
+that behaves the same across different versions.")
+    (license license:expat)))
+
 (define-public node-resolve-protobuf-schema
   (package
     (name "node-resolve-protobuf-schema")
@@ -871,55 +920,6 @@ (define-public node-path-key
 particular cross-platform spellings of the PATH environment variable key.")
     (license license:expat)))
 
-(define-public node-readable-stream
-  (package
-    (name "node-readable-stream")
-    (version "3.6.0")
-    (source
-     (origin
-       (method git-fetch)
-       (uri (git-reference
-             (url "https://github.com/nodejs/readable-stream")
-             (commit (string-append "v" version))))
-       (file-name (git-file-name name version))
-       (sha256
-        (base32
-         "0ybl4cdgsm9c5jq3xq8s01201jk8w0yakh63hlclsfbcdfqhd9ri"))))
-    (build-system node-build-system)
-    (arguments
-     `(#:phases
-       (modify-phases %standard-phases
-         (add-after 'patch-dependencies 'delete-dependencies
-           (lambda args
-             (delete-dependencies `("@babel/cli"
-                                    "@babel/core"
-                                    "@babel/polyfill"
-                                    "@babel/preset-env"
-                                    "airtap"
-                                    "assert"
-                                    "bl"
-                                    "deep-strict-equal"
-                                    "events.once"
-                                    "glob"
-                                    "gunzip-maybe"
-                                    "hyperquest"
-                                    "lolex"
-                                    "nyc"
-                                    "pump"
-                                    "rimraf"
-                                    "tap"
-                                    "tape"
-                                    "tar-fs"
-                                    "util-promisify")))))
-       #:tests? #f))
-    (inputs (list node-util-deprecate node-string-decoder node-inherits))
-    (home-page "https://github.com/nodejs/readable-stream")
-    (synopsis "Node.js core streams for userland")
-    (description
-     "@code{readable-stream} provides an implementation of Node.js core streams
-that behaves the same across different versions.")
-    (license license:expat)))
-
 (define-public node-irc-colors
   (package
     (name "node-irc-colors")